<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
</head>
<body>
  <div id="app">
        <input type="text" placeholder="tambah nama" v-model:value="newName">
        <button @click="addName" v-if="addButton">Add</button>
        <button @click="updateName" v-if="updateButton">Update</button>
        <ul>
            <li v-for="item in users">{{ item.name }} 
                <button @click="editName(item.name)" >Edit</button> || 
                <button @click="deleteName(item.name)">Delete</button></li>
        </ul>
  </div>
  
  <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
  <script>
   var vm = new Vue({
      el: '#app',
      data: {
          newName : "",
          addButton : true,
          updateButton : false,
          oldName : "",
          users : [
              {
                  'name' : 'nama pertama',
              },
              {
                  'name' : 'nama kedua',
              },
              {
                  'name' : 'nama ketiga',
              }
          ],
        
      },
      methods : {
          addName: function() {
              this.users.push({'name' : this.newName.toString()})
          },
          editName: function(nameToEdit) {
              this.addButton = false
              this.updateButton = true
              this.newName = nameToEdit.toString()
              this.oldName = nameToEdit.toString()
          },
          updateName: function() {

            var index = null;

            for (var i=0; i<this.users.length; i++) {
                if ( this.users[i].name == this.oldName ) {
                    index = i;
                    break;
                }
            }

            this.users.splice(index, 1, {'name' : this.newName})
                
          },
          deleteName: function(nameToDelete) {
            var index = null;

            for (var i=0; i<this.users.length; i++) {
                if ( this.users[i].name == nameToDelete ) {
                    index = i;
                    console.log('i:'+i)
                    break;
                }
            }
     

            this.users.splice(index, 1)

          }
      }
  })
  </script>
</body>
</html>
